<template>
    <div>
        <ob-modal
          ref="ob-modal"
          :title="'Создание новой методики'"
          :size="'medium'"
          :isShowControls="true"
          :isSubmitDisabled="!formValid"
          @cancel="close"
          @submit="onSave"
          class="sb-popup sb-card-popup"
          >
            <ob-form
                :isShowControls="false"
                :formData="formData"
            >
                <!-- <div class="edit-method"> -->
                    <ob-input
                        class="edit-method"
                        :label="'Наименование'"
                        :placeholder="'Введите'"
                        type="text"
                        v-model="formData.name"
                        required
                    />
                <!-- </div>
                <div class="edit-method"> -->
                    <ob-selector
                        class="edit-method"
                        :items="roles"
                        :placeholder="'Выберите'"
                        :label="'Роль'"
                        @input="changeRole()"
                        v-model="formData.participantType"
                        required
                    />
                <!-- </div> -->
                <!-- <div class="edit-method__wrap"> -->
                    <ob-selector
                        class="edit-method"
                        :items="activities"
                        :placeholder="'Выберите'"
                        :disabled="formData.participantType !== 'CARRIER'"
                        :label="'Направление деятельности'"
                        v-model="formData.participantActivityUuid"
                        :required="formData.participantType === 'CARRIER'"
                    />
                <!-- </div> -->
                <!-- <div class="edit-method__wrap"> -->
                    <ob-textarea
                        :placeholder="'Выберите'"
                        :label="'Краткое описание'"
                        rows="10"
                        class="edit-method"
                        v-model="formData.description"
                    />
                <!-- </div> -->
            </ob-form>
        </ob-modal>
    </div>
</template>

<script>
import { uuid } from 'vue-uuid'

import ObForm from "common-components/src/obComponents/obForm";
import ObModal from 'common-components/src/obComponents/obModal';
import ObSelector from 'common-components/src/obComponents/obSelect';
import ObInput from 'common-components/src/obComponents/obInput';
import ObTextarea from 'common-components/src/obComponents/obTextarea';
import { CREATE_METHODOLOGY } from '../../../store/modules/methodologies';
import { GET_ACTIVITIES } from '../../../store/modules/activities';

export default {
    data() {
        return {
            roles: [
                {
                    "uuid": "CLIENT",
                    "title": "Клиент",
                    // "uuid": 1,
                    "is_active": true
                },
                {
                    "uuid": "CARRIER",
                    "title": "Перевозчик",
                    // "uuid": 2,
                    "is_active": true
                }
            ],
            formData: {
                name: '',
                participantType: '',
                participantActivityUuid: '',
                description: ''
            }
        }
    },
    components: {
        ObModal,
        ObSelector,
        ObInput,
        ObForm,
        ObTextarea
    },
    computed: {
        activities() {
            return this.$store.getters.getActivities;
        },
        formValid() {
            if (this.formData.name && this.formData.participantType) {
                if (this.formData.participantType !== 'CARRIER') {
                    return true;
                } else {
                    if (this.formData.participantActivityUuid) return true;
                    else return false;
                }
            } else {
                return false;
            }
        }
    },
    created() {
        this.$store.dispatch(GET_ACTIVITIES)
        console.log('activities')
        console.log(this.activities)
    },
    methods: {
        async onSave() {
            console.log('onSave')
            const payload = {
                uuid: uuid.v4(),
                name: this.formData.name,
                description: this.formData.description,
                participantType: this.formData.participantType,
                participantActivityUuid: this.formData.participantActivityUuid,
            }
            try {
                await this.$store.dispatch(CREATE_METHODOLOGY, payload)
            } catch (ex) {
                console.log(ex)
            }
            this.$emit('create', payload)
            this.close();
        },
        changeRole() {
            console.log('changed role')
            console.log(this.formData.participantActivityUuid)
            this.formData.participantActivityUuid = '';
        },
        open(data) {
            this.$refs['ob-modal'].open();
            if (uuid) {
                // this.formData = JSON.parse(JSON.stringify(templateData));
                // const data = await this.fetch(uuid);
                // console.log(data);
                // this.formData = data;
                this.formData.name = data;
            }
        },
        close() {
            this.formData = {
                name: '',
                participantType: '',
                participantActivityUuid: '',
                description: ''
            }
            this.$refs['ob-modal'].close();
        }
    }
}
</script>

<style lang="scss" scoped>
.edit-method {
    margin: 10px 0;
    // display: flex;
    // padding: 10px 0;
    // justify-content: space-between;
    &__label {
        width: 30%;
    }
    &__input {
        width: 70%;
    }
    &__input {
        margin: 0;
    }
    &__check {
        align-self: center;
        margin: auto;
    }
    &__wrap {
        flex-wrap: wrap;
        .text-field {
            width: 100%;
            overflow-y: scroll;
            resize: none;
            border: 1px solid #D1D2D6;
            border-radius: 3px;
        }
    }
}
</style>
